/*
 * ByteArray.h
 *
 *  Created on: Apr 12, 2014
 *      Author: cihan
 */

#ifndef BYTEARRAY_H_
#define BYTEARRAY_H_

#include <stdio.h>
#include <string.h>

class ByteArray {
public:
	ByteArray();
	virtual ~ByteArray();

	//why do i need to define size of data?
	ByteArray(unsigned int size);

	unsigned int Size();
	unsigned char *Data();
	char * Name();


	bool SetDataFromHexString(const char * hex_string);
	bool SetName(const char * name);

	//Deprecated
	char * GetName();


	void Clear();


	bool FromData(unsigned char *data, unsigned int size);
	bool RemoveByteArrayFromBegin(ByteArray &byte_array, unsigned int size);
	bool Clone(ByteArray byte_array);
	bool PrintAsHexString();
	bool AddByteArrayToEnd(ByteArray byte_array);
	unsigned int ToUnsignedInt();
	bool Count(bool resizeable);

	//Logic
	bool LogicOrWith(ByteArray byte_array);
	bool LogicAndWith(ByteArray byte_array);
	bool LeftCircularShift(unsigned int number_of_bits);
	bool RightCircularShift(unsigned int number_of_bits);
	bool IsEqual(ByteArray byte_array);

private:
	unsigned int 	m_size;
	unsigned char * m_data;
	char * m_name;
};

#endif /* BYTEARRAY_H_ */
